<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: show_zone.inc,v 1.20 2003/08/14 19:07:01 vollmerk Exp $
 $Source: /a1/cvsroot/maint/templates/show_zone.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Zone Template
	Template for viewing a single zone and editing it. 

*/

// for those who are just searching, or aren't in a zone currently. 
if (get_class($zone) == 'Zone') { $domains = $zone->domains(); }

// Get the object_history information
$history = $zone->object_history->get_history();

?>

<? if ($action_type) { ?>
<p><font class="header2">
<?
if ($action_type == "modified") { echo "Updated $zone->name with the following information"; }
elseif ($action_type == "read") { echo "Viewing $zone->name"; }
?>
</font>
&nbsp;
<? if ($user->has_access($zone->id)) { ?>
<a href = "<?= $conf['web_path']; ?>/zone.php?action=show_zone&zone_id=<?= $zone->id; ?>">[Edit]</a>&nbsp;&nbsp;
<a href = "<?= $conf['web_path']; ?>/zone.php?action=delete&zone_id=<?= $zone->id; ?>">[Delete]</a>
<? } ?>
</p>
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%" bgcolor="<?= $conf['light_bgcolor']; ?>">
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt("host"); ?>">
		Hosts:<? $conf['ui']->display_field(commity(count_host($zone->id))); ?>
	</td>
        <td>
		<a href="<?= $conf['web_path']; ?>/host.php?action=show_hosts&view_zone_id=<?= $zone->id; ?>">Show Hosts</a>
        </td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt("cname"); ?>">
		CNAMEs:<? $conf['ui']->display_field(commify(count_cname($zone->id))); ?>
	</td>
        <td>
		<a href="<?= $conf['web_path']; ?>/cname.php?action=show_cnames&view_zone_id=<?= $zone->id; ?>">Show Cnames</a>
        </td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt("mxrecord"); ?>">
		MX's:<? $conf['ui']->display_field(commify(count_mx($zone->id))); ?>
	</td>
	<td>
	<a href="<?= $conf['web_path']; ?>/mx.php?action=show_mxs&view_zone_id=<?= $zone->id; ?>">Show MXs</a>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td colspan="2" >Merge <? $conf['ui']->display_field($zone->name); ?> with:</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt("domain"); ?>">Current Domain(s): </td>
        <td><? //display domains attached to this zone
		$domains = $conf['zone']->domains($zone->id);
		if (count($domains) == "0") { echo "No Domains Found"; }
		elseif (count($domains) == "1") { 
			$domain = new Domain($domains[0]->id); 
			echo "$domain->name"; 
			}
		elseif (count($domains) > "1") 
			{ 
			$conf['ui']->show_domain_select($domains,$domains[0]->id); 
			}
		?>
        </td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="left">
	<td title="<? $conf['help']->display_plain_txt("users"); ?>">Current Users:</td>
	<td><? //show current users
		$users = $zone->get_users();
		if (count($users) > "1") { $conf['ui']->show_user_select($users, $users[0]);	}
		elseif (count($users) == "1") { echo $users[0]->username; }
		elseif (count($users) == "0") { echo "No Users Found"; }
		?>
	</td>
</tr>
</table>

<? show_template('bborder'); ?>

<? 
} 
/*****************************
	END OF VIEW
*****************************/
else { 
?>
<p class="header2">Editing <?= $zone->name; ?> information</p>

<form name="edit_zone" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/zone.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
	<td colspan="3" class="widget-title">Update Zone Information</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
    	<td title="<? $conf['help']->display_plain_txt("zone_name"); ?>"><? $conf['help']->show_help_link("zone_name"); ?> Name: </td>
        <td>
                <input name="name" value="<?= $zone->name; ?>" size="35" />
		<? $conf['error']->show_message('name'); ?>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td valign="top">Comment:</td>
	<td valign="top">
		<textarea cols="35" rows="4" name="comment"><?= $zone->comment; ?></textarea>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt("zone_purageable"); ?>"><? $conf['help']->show_help_link('zone_purgeable'); ?> Set Zone Purgability:</td>
	<td>
		<input type="checkbox" name="purgeable" value="true" <? if ($zone->purgeable == 'true') { echo "CHECKED"; } ?>>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
        <td title="<? $conf['help']->display_plain_txt("who_update"); ?>"><? $conf['help']->show_help_link("who_update"); ?> Last Updated By: </td>
        <td>
        <? if ($history->username) { ?>
        	<? $conf['ui']->display_field($history->username); ?><?= " on " . date("F j, Y",$history->date) . " at " . date("g:i a",$history->date); ?>
        <? } else { ?>
        	N/A
        <? } ?>
	</td>
</tr>
<? 
$child = new Child("zone",$zone->id,0,0,'count');
if ($child->has_children) { 
?>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td><?= $child->total; ?> Child Object(s)</td>
	<td>
	<a href="<?= $conf['web_path']; ?>/zone.php?action=show_children&zone_id=<?= $zone->id; ?>">[ Show Children ]</a>
	</td>
</tr>
<? } ?>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>&nbsp;</td>
	<td>
		<input type="hidden" name="zone_id" value="<?= $zone->id ?>" />
		<input type="hidden" name="action" value="update_zone" />
		<input type="submit" value="Update" />&nbsp;&nbsp;
		<input type="submit" name="action" value="Delete Zone" />&nbsp;&nbsp;
		<input type="submit" value="Cancel" />
	</td>
</tr>
</table>
<? show_template('bborder'); ?>
</form>
<br /><br />
<!-- End Update Start Domain Modification -->
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
	<td colspan="3" class="widget-title">Update Domain to Zone mapping</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt('zone_domain'); ?>"><? $conf['help']->show_help_link("zone_domain"); ?> Add Domain:</td>
	<td>
	<? 
		$domain = new Domain(0);
		$domains = $domain->domains();
	?>
		<form method="post" action="<?= $conf['web_path']; ?>/zone.php" enctype="multipart/form-data" style="Display:inline">
		<? $conf['ui']->show_domain_select($domains,$domain[0]->id); ?>
		<input type="hidden" name="zone_id" value="<?= $zone->id; ?>" />
		<input type="hidden" name="action" value="add_domain" />
	</td>
	<td>
		<input type="Submit"  value="Add Domain" />
		</form>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt('zone_domain'); ?>"><? $conf['help']->show_help_link('zone_domain'); ?> Remove Domains:</td>
	<td>
	<? //display domains attached to this zone
		$domains = $conf['zone']->domains($zone->id);
		if (count($domains) < 1) { echo "No Domains Found</td><td>"; }
		elseif (count($domains)) { 
	?>
	<form method="post" action="<?= $conf['web_path']; ?>/zone.php" enctype="multipart/form-data" style="Display:inline">
	<? $conf['ui']->show_domain_select($domains,$domains[0]->id); ?>
	<input type="hidden" name="zone_id" value="<?= $zone->id; ?>" />
	<input type="hidden" name="action" value="remove_domain" />
	</td>
	<td>
	<input type="Submit"  value="Remove Domain" />
	</form>
	<? } // end elseif ?>
	</td>
</tr>
</table>
<? show_template('bborder'); ?>
<br />
<!-- End Domain Update Start User Modification -->
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
	<td class="widget-title" colspan="3">Update User permissions on this Zone</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->display_plain_txt("username"); ?>"><? $conf['help']->show_help_link("username"); ?> Add Users:</td>
	<td>
		<form action="<?= $conf['web_path']; ?>/zone.php" method="post" enctype="multipart/form-data" style="display:inline">
		Username:<input type="textbox" name="username" size="20" />&nbsp;&nbsp;
		<select name="level">
			<option value="50">Zone Admin</option>
			<option value="25">Zone User</option>
			<option value="5">Zone Guest</option>
		</select>
		<? $conf['error']->show_message('username'); ?>
	</td>
	<td>
		<input type="hidden" name="action" value="add_user" />
		<input type="submit" value="Add User" />
		<input type="hidden" name="zone_id" value="<?= $zone->id; ?>" />
		</form>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>Remove Users:</td>
	<td><? //remove users from a zone
	$users = $zone->get_users();
	if (count($users)) { 
		echo "<form method=\"post\" enctype=\"multipart/form-data\" style=\"Display:inline\" action=\"zone.php\">"; 
		$conf['ui']->show_user_select($users,$users[0]); 
		echo "<input type=\"hidden\" name=\"action\" value=\"remove_user\" />";
		echo "<input type=\"hidden\" name=\"zone_id\" value=\"$zone->id\" />";
		echo "</td><td><input type=\"submit\" value=\"Remove User\" /></form>\n";
	}
	elseif (count($users) < 1) { echo "No Users Found"; }
	?>
</tr>
</table>
<? show_template('bborder'); ?>
</form>
<br />
<!-- End of user start of range --> 
<p class="header2">Zone to Range Mappings</p>
<? 
$ranges = $zone->ip_ranges();
require ($conf['prefix'] . "/templates/show_zone_ranges.inc"); 
require ($conf['prefix'] . "/templates/show_zone_workgroup.inc");
} 
?>
